assert(1 == 0) # do not use me
import collections
import functools
import random
from enum import *







CFG = collections.namedtuple("CFG", "nonterminals terminals rules start")
# We define a context-free grammar as:
# 1. A list of nonterminal symbols
# 2. A list of terminal symbols
# 3. A list of production rules
# 4. A start symbol.

# Each symbol is defined by a positive integer.


# For the ETF expression grammar:

# Terminal symbols are:
# INTEGER, ADDOP, MULTOP, OPENPAREN, CLOSEPAREN

# Nonterminal symbols are:
# EXPRESSION, TERM, FACTOR

# The start symbol is EXPRESSION

# The rules are:

# EXPRESSION -> EXPRESSION ADDOP TERM
# EXPRESSION -> TERM
# TERM -> TERM MULTOP FACTOR
# TERM -> FACTOR
# FACTOR -> OPENPAREN EXPRESSION CLOSEPAREN
# FACTOR -> INTEGER

#symbols = Enum("Symbols", "EXPRESSION TERM FACTOR INTEGER ADDOP MULTOP OPENPAREN CLOSEPAREN")

nonterminals = Enum("Nonterminals", "EXPRESSION TERM FACTOR")

terminals = Enum("Terminals", "INTEGER ADDOP MULTOP OPENPAREN CLOSEPAREN")

list_of_nonterminals = [e for e in nonterminals]
list_of_terminals    = [e for e in terminals]

start = nonterminals.EXPRESSION

# The rules are a list of tuples, each of which represents a rule, as follows:

# (Nonterminal symbol, [ordered list of symbols (terminal or nonterminal) that are reduced to aforementioned nonterminal])

rules = [
         (nonterminals.EXPRESSION, [nonterminals.EXPRESSION, terminals.ADDOP,      nonterminals.TERM      ]),
         (nonterminals.EXPRESSION, [nonterminals.TERM                                              ]),
         (nonterminals.TERM,       [nonterminals.TERM,       terminals.MULTOP,     nonterminals.FACTOR    ]),
         (nonterminals.TERM,       [nonterminals.FACTOR                                            ]),
         (nonterminals.FACTOR,     [terminals.OPENPAREN,  nonterminals.EXPRESSION, terminals.CLOSEPAREN]),
         (nonterminals.FACTOR,     [terminals.INTEGER                                           ])
         ]

#print(rules)



# Once we have a CFG's definition, we can use Boltzmann sampling in order to generate random strings
# from that CFG.


# This, however, is not Boltzmann sampling.

# We examine all the leaves on the current derivation tree. Those mark where we possibly could apply a rule.
# We then determine which leaves are amenable to rule application, and then we randomly select a leaf and for
# that leaf, we randomly select a rule, and apply it.

# To avoid being accidentally quadratic, we cache a list of the leaves, and also cache the current length of
# the generated string (in order to do pseudo-Boltzmann sampling).


def indexes_to_item(tree, location):
    opsite = tree
    if (location != []):
        for depth_index in location:
            opsite = opsite.subnodes[depth_index]
            #print("TMP index ", depth_index, " gives ",opsite)
    else:
        opsite = tree

    return opsite

def random_leaf_random_rule(tree, leafcache, ruleset):

    for x in range(16):
        proband_cache_index = random.randrange(len(leafcache))
        location = leafcache[proband_cache_index]

        opsite = indexes_to_item(tree, location)

        proband_rule_index = random.randrange(len(ruleset))
        rule = ruleset[proband_rule_index]

        if (opsite.language_element == rule[0]):
            return (proband_cache_index, proband_rule_index)


    # we failed somehow, just return None
    return None






def apply_rule(tree, leafcache, cache_index, ruleset, rule_number):
    # first, we isolate the place on the tree that we are going to do the graft.
    opsite = tree

    location = leafcache[cache_index]

    opsite = indexes_to_item(tree, location)

    #print(opsite)
    #walk_the_tree(opsite)

    # now we verify that we can legitimately apply the given rule here.

    the_rule = ruleset[rule_number]

#    print("We will try applying the following rule:", the_rule)

    # We verify that the item at the operation site is:
    # 1) a leaf (it has no subnodes)
    # and
    # 2) has the correct value

#    print("Opsite language value", opsite.language_element)
#    print("Rule expects", the_rule[0])

    assert(opsite.language_element == the_rule[0])

    assert(opsite.subnodes == [])

#    print("opsite has no subnodes, all good")

    new_leaves = []

    for idx, new_subnode in enumerate(the_rule[1]):
        #print(new_subnode)
        x = TreeNode(new_subnode, [])
        opsite.subnodes.append(x)

        leafcache.append(location + [idx])

#    print("Now the opsite looks like")
#    walk_the_tree(opsite)

    # update the leaf cache

    del leafcache[cache_index]



#def next_stage(derivation_tree_with_cached, language_definition):




def the_tree_farm():
    for x in range(16):
        selected = random_leaf_random_rule(test_tree, leafcache, rules)
        if (selected == None):
            # we have achieved what we need! all leaves are terminal items
            return test_tree
        else:
            (next_index_cache, next_rule) = selected

#        print ("next cache index is", next_index_cache, "next rule is", next_rule)
        apply_rule(test_tree, leafcache, next_index_cache, rules, next_rule)

#        print("and the tree looks like")
        #walk_the_tree(test_tree)

#        print("updated leafcache")
#        print(leafcache)

#


test_tree = TreeNode(nonterminals.EXPRESSION, [])

#walk_the_tree(test_tree)


def tree_to_sentence(tree_root, leaves):
    for node in tree_root.subnodes:
        if node.subnodes == []:
            leaves.append(node.language_element)
        else:
            tree_to_sentence(node, leaves)




if __name__ == '__main__':

    leafcache = [[]]

    while False:
        produced_tree = the_tree_farm()
        if(produced_tree != None):
            print("SUCCESS!!!!")
            walk_the_tree(produced_tree)
            print("now to try to extract the sentence,,")
            leaves = []
            tree_to_sentence(produced_tree, leaves)
            print(leaves)
            break



