from nmigen import *
from nmigen.cli import main

from functools import reduce





class DummyPlug(Elaboratable):
    def elaborate(self, platform):
        m = Module()
        ctr = Signal(8)

        phase = Signal(1)
        one_hot = Signal(1)
        two_hot = Signal(1)


        with m.If(phase == 0):
            m.d.sync += ctr.eq(ctr+1)
            m.d.comb += one_hot.eq(0)
            m.d.comb += two_hot.eq(0)
            m.d.sync += phase.eq(1)




        with m.If(phase == 1):
            m.d.sync += phase.eq(0)
            m.d.comb += one_hot.eq(0 == (ctr & (ctr - 1)))
            m.d.comb += two_hot.eq(~one_hot)

        return m


if __name__ == '__main__':
    baka =DummyPlug()
    main(baka)

