from nmigen import *
from nmigen.cli import main

from functools import reduce


class FsmTest(Elaboratable):

    def __init__(self):
        self.x = Signal(16)
        self.stall = Signal(2)

    def elaborate(self, platform):
        m = Module()
        with m.FSM() as fsm:
            with m.State("Ingest"):
                m.d.sync += self.x.eq(self.x+1)
                m.d.comb += self.stall.eq(0b10)
                with m.If(self.x == 4):
                    m.d.comb += self.stall.eq(0b11)
                    m.next="Stall"
            with m.State("Stall"):
                m.d.comb += self.stall.eq(0b11)

                m.d.sync += self.x.eq(self.x-1)
       
        return m



if __name__ == '__main__':
    baka = FsmTest()
    main(baka)
